/*
   Filename: DataStore.cpp

   The DataStore class stores data for the various objects
   in IIKH.

   Last Updated: 04/25/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.

*/

#include "DataStore.h"

//-------------------------------------------------------------------------------------
DataStore::DataStore()
{
   // do nothing.
}
//-------------------------------------------------------------------------------------
DataStore::~DataStore()
{

}
//-------------------------------------------------------------------------------------
vector<Recipe>* DataStore::getRecipes() 
{
	return &theRecipes;
}
//-------------------------------------------------------------------------------------
vector<Meal>* DataStore::getMeals() 
{
	return &theMeals;
}
//-------------------------------------------------------------------------------------
vector<Plan>* DataStore::getPlans() 
{
	return &thePlans;
}
//-------------------------------------------------------------------------------------
void DataStore::parseRecipeFile()
{
	string title;
	string category;
	string directions;
	string temp;
	int recipes = 0;

	// kill an endless loop.
	int count = 0;

	

	//stringstream s;

	float servings;
	list<string> ingredients; // = new list<string>;

	ifstream rdr("Recipes.txt", ios::in);
	if(!rdr)
	{
		fl_alert("Error!! Can't find Recipes.txt");
		return;
	}

	while(rdr && temp != "---")
	{
		directions = "";
		temp = "";

		getline(rdr, title);
		getline(rdr, category);
		rdr >> servings;
		getline(rdr, temp); // get the newline char

		// get ingredients
		getline(rdr, temp);
		while(temp != "***")
		{
			count++;
			ingredients.push_back(temp);
			getline(rdr, temp);
			if(count > 150) 
			{
#ifdef WIN32
				fl_alert("-- SEVERE --\nThere was a problem reading Recipes.txt!");
#else
				cout << "-- SEVERE --\nThere was a problem reading Recipes.txt!\n";
#endif
				exit(1);
			}

		}
		// get directions
		getline(rdr, temp);
		count = 0;

		while(temp != "***" && temp != "---")
		{
			count++;
			directions = directions + temp + '\n';
			getline(rdr, temp);
			if(count > 150) 
			{
#ifdef WIN32
				fl_alert("-- SEVERE --\nThere was a problem reading Recipes.txt!");
#else
				cout << "-- SEVERE --\nThere was a problem reading Recipes.txt!\n";
#endif
				exit(1);
			}

		}

		recipes++;

		{
			Recipe a(title, category, servings, ingredients, directions);
			theRecipes.push_back(a); 
		}
		ingredients.clear();
	}

}
//-------------------------------------------------------------------------------------
void DataStore::writeRecipeFile()
{
	// write first record, then enter loop.

	ofstream out("Recipes.txt");

	list<string> ingtemp;

	if(theRecipes.size() > 0)
	{
		out << theRecipes[0].getTitle() + '\n'; 
		out << theRecipes[0].getCategory() + '\n';
		out << theRecipes[0].getServings() << '\n';

	// write out ingredients.

		ingtemp = theRecipes[0].getIngredients();
		list<string>::iterator p = ingtemp.begin();
		while(p != ingtemp.end() )
		{
			out << *p << '\n';
			p++;
		}

		// write out seperater
		out << "***\n";
		out << theRecipes[0].getDirections();
		
		for(unsigned int i = 1; i < theRecipes.size(); i++) // we already wrote out 0
		{
			out << "***\n";
			out << theRecipes[i].getTitle() + '\n'; 
			out << theRecipes[i].getCategory() + '\n';
			out << theRecipes[i].getServings() << '\n';
			
			// write out ingredients.
			
			ingtemp = theRecipes[i].getIngredients();
			list<string>::iterator p = ingtemp.begin();
			while(p != ingtemp.end() )
			{
				out << *p << '\n';
				p++;
			}
			// write out seperater
			
			out << "***\n";
			out << theRecipes[i].getDirections();
		}

		out << "---";   // end of file.
	}

	out.close();

}
//-------------------------------------------------------------------------------------
void DataStore::storeMeal(Meal m) 
{
	savedMeal = m;
}
//-------------------------------------------------------------------------------------
Meal DataStore::getMeal() 
{
	return savedMeal;
}
//-------------------------------------------------------------------------------------


