#ifndef DATASTORE_H
#define DATASTORE_H

/*
   Filename: DataStore.h

   The DataStore class stores data for the various objects
   in IIKH.

   Last Updated: 04/13/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.

*/

//#include <iostream>
#include <fstream>
#include <vector>
#include <sstream>

#include <FL/fl_ask.H>

#include "Recipe.h"
#include "Meal.h"
#include "Plan.h"


using namespace std;


class DataStore
{
    public:
		DataStore();
		~DataStore();
		vector<Recipe>* getRecipes();
		vector<Meal>* getMeals();
		vector<Plan>* getPlans();


		void parseRecipeFile();

		void writeRecipeFile();

		void storeMeal(Meal m);
		Meal getMeal();

    private:
		vector<Recipe> theRecipes;
		vector<Meal> theMeals;
		vector<Plan> thePlans;

		list<string> grocerycart;

		Meal savedMeal;





};


#endif	/* DATASTORE_H */
