/*
   Filename: Meal.h

   The Meal class represents a Meal, it obtains the recipe,
   scales the servings, and stores all the required
   ingredients for that recipe.



   Last Updated: 04/14/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.


   TODO: Needs support for multiple recipes.
         ( I put 4 here. Drink, Appetizer, Main Course, Dessert)
         There needs to be at least 1 recipe, and no more then 4.
         So if a meal consisted of only Main Course, the rest of the
         array would be NULL.

         *Persistance (the ability to save and read from file)  ??

*/

#include "Meal.h"

//-------------------------------------------------------------------------------------
Meal::Meal() // default constructor
{
	// do nothing.

}
//-------------------------------------------------------------------------------------
Meal::Meal(vector<Recipe> r, string theDate, string theName, int people)
{
	theRecipes = r;
    date = theDate;
    name = theName;
    numberOfPeople = people;
    //cart = new list<string>;
}
//-------------------------------------------------------------------------------------
Meal::~Meal()
{
//	delete cart;
}
//-------------------------------------------------------------------------------------
string Meal::getRecipeTitle(int i)
{
    return theRecipes[i].getTitle();
}
//-------------------------------------------------------------------------------------
string Meal::getMealDate()
{
   return date;
}
//-----------------------------------------------------------------------
string Meal::getMealName()  
{
   return name;
}      
//-----------------------------------------------------------------------
list<string> Meal::getRecipeIngredients()
{
   return cart;

}
//-----------------------------------------------------------------------
vector<Recipe> Meal::getRecipes()
{
   return theRecipes;

}
//-----------------------------------------------------------------------
float Meal::scaleServings(int i)
{
	float size = theRecipes[i].getServings();
    float scale = size/numberOfPeople;  
    return scale;       
}
//-----------------------------------------------------------------------
void Meal::addGroceryItems()
{
	string item, scaledItem;    
	float quantity;    

    for(int i = 0; i < 4; i++)
	{

		list<string> ingrd = theRecipes[i].getIngredients(); 
		
		if(ingrd.empty()) break;  // no more meals
		
		list<string>::iterator p = ingrd.begin();
		while(p != ingrd.end() )
		{
			string temp = *p;
			int pos = temp.find(';');

			if(pos != -1) {    // modern compilers can use npos
				// if we found a ;			

				quantity = (float) atof(temp.substr(0,pos).c_str());
				// take the substing, convert it to char *,
				// convert char* to double, cast to float.
				// If there is a better way to do this, put it in
				// or let me know.
				
				quantity = quantity * scaleServings(i); 

				// we may need to make new objects here,
				// i'm not really sure.. need to create
				// a driver class.
				
				scaledItem = quantity;
				// make a new string with the number.

				scaledItem = scaledItem + " " + temp.substr(pos,temp.size());
					
				cart.push_back(scaledItem);
			}
        
			p++;
		}
	}
}
//-------------------------------------------------------------------------------------
void Meal::removeGroceryItems()
{
	//empty the list of ingredients when recipe gets deleted
   cart.clear();
}
//-------------------------------------------------------------------------------------
int Meal::getMealPeople()
{
	return numberOfPeople;
}
//-------------------------------------------------------------------------------------