#ifndef MEAL_H
#define MEAL_H

/*
   Filename: Meal.h

   The Meal class represents a Meal, it obtains the recipe,
   scales the servings, and stores all the required
   ingredients for that recipe.



   Last Updated: 04/14/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.


   TODO: Needs support for multiple recipes.
         ( I put 4 here. Drink, Appetizer, Main Course, Dessert)
         There needs to be at least 1 recipe, and no more then 4.
         So if a meal consisted of only Main Course, the rest of the
         array would be NULL.

         *Persistance (the ability to save and read from file)  ??

*/

#include <iostream>
#include <string>
#include <list>
#include <vector>

#include "Recipe.h"

using namespace std;

class Meal
{
    public:
  		Meal();
  		Meal(vector<Recipe> r, string theDate, string theName, int people);
  		
		~Meal();

		string getRecipeTitle(int i);
		string getMealDate();
		string getMealName();
		int getMealPeople();
		list<string> getRecipeIngredients();
		float scaleServings(int i);
		void addGroceryItems();
		void removeGroceryItems();
		vector<Recipe> getRecipes();


		//void writeToFile();

    private:
		list<string> cart;
		int numberOfPeople;
		string date, name;
		vector<Recipe> theRecipes;


};

#endif	/* MEAL_H */
