#ifndef PLAN_H
#define PLAN_H

/*
   Filename: Plan.h

   Description: A Plan Object representing each Plan that needs to
                be added/edited/deleted from PlanBrowser.



   Last Updated: 04/14/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.


   TODO: *Persistance (the ability to save and read from file)  ??

*/

#include <iostream>
#include <string>
#include <vector>

#include "Meal.h"

using namespace std;

class Plan
{
    public:
  	Plan();
  	Plan(string theName, string theDate, vector<Meal> m);
  	void addMeal(Meal newMeal);

	string getName();
	string getDate();
	vector<Meal> getMealList();

    private:
	string Name;
	string Date;
	vector<Meal> thisMeal;   // Visual C++ doesn't like a constant here.
};

#endif	/* PLAN_H */
