#ifndef PLANBROWSER_H
#define PLANBROWSER_H

/*
   Filename: planbrowser.h

   The PlanBrowser class represents the a browser like
   object to browse and manipulate Plans

   Last Updated: 04/23/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.

*/

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Hold_Browser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Round_Button.H>
#include <FL/Fl_Int_Input.H>
#include <FL/Fl_Output.H>

#include "DataStore.h"

#include <map>

class PlanBrowser
{
    public:
		PlanBrowser(DataStore *ds);
		~PlanBrowser();
		void update();

    private:
		vector<Meal> *theMeals; // all meals
		vector<Plan> *thePlans;

		vector<Meal> vm; // only meals displayed.

		vector<float> amount;			// grocerylist
		vector<string> ingredlist;		// grocerylist


		DataStore *theDataStore;

		Fl_Round_Button* selected;
		Fl_Round_Button* range;
		Fl_Round_Button* all;

		Fl_Int_Input *from;
		Fl_Int_Input *to;


		Fl_Hold_Browser *mlist;
		Fl_Hold_Browser *plist;
		Fl_Input *planNameInput;
		Fl_Input *dateInput;

		static void cb_Viewb(Fl_Widget *w, void* data);
		void cb_Viewb_i(Fl_Widget *w);

		static void cb_Delb(Fl_Widget *w, void* data);
		void cb_Delb_i(Fl_Widget *w);

		static void cb_Addb(Fl_Widget *w, void* data);
		void cb_Addb_i(Fl_Widget *w);

		static void cb_selpb(Fl_Widget *w, void* data);
		void cb_selpb_i(Fl_Widget *w);

		static void cb_Delpb(Fl_Widget *w, void* data);
		void cb_Delpb_i(Fl_Widget *w);

		static void cb_grocb(Fl_Widget *w, void* data);
		void cb_grocb_i(Fl_Widget *w);

		static void cb_savegrocb(Fl_Widget *w, void* data);
		void cb_savegrocb_i(Fl_Widget *w);

		static void cb_print(Fl_Widget *w, void* data);
		void cb_print_i(Fl_Widget *w);

		static void cb_doPrinting(Fl_Widget *w, void* data);
		void cb_doPrinting_i(Fl_Widget *w);

		static void cb_destroygwin(Fl_Widget *w, void* data);
		void destroy_groc_window( Fl_Widget *w);

};

extern void back2_cb(Fl_Widget*,void*); // iikh.cxx
extern void gonext_cb(Fl_Widget*,void*);
extern void goMealUpdate_cb(Fl_Widget*,void*);

#endif	/* PLANBROWSER_H */
