/*
   Filename: Recipe.h

   The Recipe class represents a data structure to hold
   a single recipe.

   Last Updated: 04/14/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.

*/

#include "Recipe.h"

//-------------------------------------------------------------------------------------
Recipe::Recipe()
{
	title="";
	category="";
	servings=0;
    directions="";
	//ingredients = new list<string>;

}
//-------------------------------------------------------------------------------------
Recipe::Recipe(string t, string c, float s, list<string> i,string d)
{
	title=t;
    category=c;
    servings=s;
    ingredients=i;
    directions=d;
}
//-------------------------------------------------------------------------------------
Recipe::~Recipe()
{
	
}
//-------------------------------------------------------------------------------------
//Recipe* Recipe::getRecipe(){
//	return this;
//}
//  Huh ??
//  "Student b = a;" is "Student *b = a->getStudent();"
//  "Student *s = myStudent.getStudent();" identical to: "Student *s = &myStudent;"
//
//
//-------------------------------------------------------------------------------------
list<string> Recipe::getIngredients() //const
{
    return ingredients;
}
//-------------------------------------------------------------------------------------
string Recipe::getTitle() const
{
    return title;
}
//-------------------------------------------------------------------------------------
string Recipe::getCategory() const
{
    return category;
}
//------------------------------------------------------------------------
string Recipe::getDirections() const
{
    return directions;
}
//------------------------------------------------------------------------
float Recipe::getServings() const
{
    return servings;
}
//------------------------------------------------------------------------
void Recipe::setTitle(string t)
{
    title=t;
}
//------------------------------------------------------------------------
void Recipe::setCategory(string c)
{
    category=c;
}
//------------------------------------------------------------------------
void Recipe::setServings(float s)
{
    servings=s;
}
//------------------------------------------------------------------------
void Recipe::setIngredients(list<string> l)
{
    ingredients = l;
}
//------------------------------------------------------------------------
void Recipe::setDirections(string d)
{
    directions=d;
}
//------------------------------------------------------------------------
void Recipe::writeToFile()
{
	ofstream out("Recipe.dat", ios::ate);  // AT End

	out << title << '\n';
	out << category << '\n';
	out << servings << '\n';

	// write out ingredients.

	list<string>::iterator p = ingredients.begin();
	while(p != ingredients.end() )
	{
		out << *p << '\n';
		p++;
	}

	// write out seperater
	out << "***\n";
	out << directions;
	out << "\n***\n";
}
//------------------------------------------------------------------------
bool Recipe::containsKeyword(string key)
{
	string temp;

	int pos = 0;
	pos = title.find(key,0);
	if(pos >= 0) return true;

	pos = category.find(key,0);
	if(pos >= 0) return true;

	pos = directions.find(key,0);
	if(pos >= 0) return true;

	// finally lets search ingredients.

	list<string>::iterator p = ingredients.begin();
	while(p != ingredients.end() )
	{
		temp = *p;
		pos = temp.find(key,0);
		if(pos >= 0) return true;
		p++;
	}

	//if we havn't returned true yet, the keyword isn't in this recipe
	return false;
}
