#ifndef RECIPE_H
#define RECIPE_H

/*
   Filename: Recipe.h

   The Recipe class represents a data structure to hold
   a single recipe.

   Last Updated: 04/14/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.

*/

#include <iostream>
#include <string>
#include <list>
#include <fstream>

using namespace std;

class Recipe
{
    public:
  		Recipe();
  		Recipe(string t, string c, float s, list<string> i, string d);
  		Recipe(ifstream &rdr);
		~Recipe();
		
		list<string> getIngredients(); // const;
		string getTitle() const;
		string getCategory() const;
		string getDirections() const;
		float getServings() const;

		void setTitle(string t);
		void setCategory(string c);
		void setServings(float s);
		void setIngredients(list<string> l);
		void setDirections(string d);

		bool containsKeyword(string key);

		void writeToFile();

    private:
		string title;
		string category;
		float servings;
		list<string> ingredients;
		string directions;

};

#endif	/* RECIPE_H */
