#ifndef IIKH_H
#define IIKH_H

/*
   Filename: iikh.h

   The IIKH class represents the code for the GUI and and also
   the main object.

   Last Updated: 04/13/04
   Written by: Erik Waibel, Devin Smith, James Wong, Phan Su.

*/

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_JPEG_Image.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Wizard.H>
#include <FL/Fl_Multiline_Output.H>
#include <stdlib.h>

#include <FL/Fl_Help_Dialog.H>


#include "RecipeBrowser.h"
#include "PlanBrowser.h"
#include "MealBrowser.h"
#include "DataStore.h"

RecipeBrowser *rb;
PlanBrowser *pb;
MealBrowser *mb;

class IIKH
{
    public:
		IIKH();

    private:

};

/* All callbacks must be static void, and can not be
   members of a class */
static void about_cb(Fl_Widget *w, void *userdata);
static void destroy_dlg_window( Fl_Widget *, void * );
static void help_cb(Fl_Widget *w, void *userdata);


void gotoPlans_cb(Fl_Widget*,void*);

void back2_cb(Fl_Widget*,void*);
void next_cb(Fl_Widget*,void*);

/* A window for all system dialogs not related to IIKH */
Fl_Window *dlg_window;
Fl_Wizard *G_wiz;

void repaintMain();

#endif	/* IIKH_H */
